var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));

// ../../node_modules/lorem-ipsum/dist/constants/formats.js
var require_formats = __commonJS({
  "../../node_modules/lorem-ipsum/dist/constants/formats.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.FORMAT_PLAIN = exports.FORMAT_HTML = exports.FORMATS = void 0;
    var FORMAT_HTML = "html";
    exports.FORMAT_HTML = FORMAT_HTML;
    var FORMAT_PLAIN = "plain";
    exports.FORMAT_PLAIN = FORMAT_PLAIN;
    var FORMATS = [
      FORMAT_HTML,
      FORMAT_PLAIN
    ];
    exports.FORMATS = FORMATS;
  }
});

// ../../node_modules/lorem-ipsum/dist/constants/units.js
var require_units = __commonJS({
  "../../node_modules/lorem-ipsum/dist/constants/units.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.UNIT_WORDS = exports.UNIT_WORD = exports.UNIT_SENTENCES = exports.UNIT_SENTENCE = exports.UNIT_PARAGRAPHS = exports.UNIT_PARAGRAPH = exports.UNITS = void 0;
    var UNIT_WORDS = "words";
    exports.UNIT_WORDS = UNIT_WORDS;
    var UNIT_WORD = "word";
    exports.UNIT_WORD = UNIT_WORD;
    var UNIT_SENTENCES = "sentences";
    exports.UNIT_SENTENCES = UNIT_SENTENCES;
    var UNIT_SENTENCE = "sentence";
    exports.UNIT_SENTENCE = UNIT_SENTENCE;
    var UNIT_PARAGRAPHS = "paragraphs";
    exports.UNIT_PARAGRAPHS = UNIT_PARAGRAPHS;
    var UNIT_PARAGRAPH = "paragraph";
    exports.UNIT_PARAGRAPH = UNIT_PARAGRAPH;
    var UNITS = [
      UNIT_WORDS,
      UNIT_WORD,
      UNIT_SENTENCES,
      UNIT_SENTENCE,
      UNIT_PARAGRAPHS,
      UNIT_PARAGRAPH
    ];
    exports.UNITS = UNITS;
  }
});

// ../../node_modules/lorem-ipsum/dist/constants/words.js
var require_words = __commonJS({
  "../../node_modules/lorem-ipsum/dist/constants/words.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.WORDS = void 0;
    var WORDS = [
      "ad",
      "adipisicing",
      "aliqua",
      "aliquip",
      "amet",
      "anim",
      "aute",
      "cillum",
      "commodo",
      "consectetur",
      "consequat",
      "culpa",
      "cupidatat",
      "deserunt",
      "do",
      "dolor",
      "dolore",
      "duis",
      "ea",
      "eiusmod",
      "elit",
      "enim",
      "esse",
      "est",
      "et",
      "eu",
      "ex",
      "excepteur",
      "exercitation",
      "fugiat",
      "id",
      "in",
      "incididunt",
      "ipsum",
      "irure",
      "labore",
      "laboris",
      "laborum",
      "Lorem",
      "magna",
      "minim",
      "mollit",
      "nisi",
      "non",
      "nostrud",
      "nulla",
      "occaecat",
      "officia",
      "pariatur",
      "proident",
      "qui",
      "quis",
      "reprehenderit",
      "sint",
      "sit",
      "sunt",
      "tempor",
      "ullamco",
      "ut",
      "velit",
      "veniam",
      "voluptate"
    ];
    exports.WORDS = WORDS;
  }
});

// ../../node_modules/lorem-ipsum/dist/constants/lineEndings.js
var require_lineEndings = __commonJS({
  "../../node_modules/lorem-ipsum/dist/constants/lineEndings.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.LINE_ENDINGS = void 0;
    var LINE_ENDINGS = {
      POSIX: "\n",
      WIN32: "\r\n"
    };
    exports.LINE_ENDINGS = LINE_ENDINGS;
  }
});

// ../../node_modules/lorem-ipsum/dist/util/capitalize.js
var require_capitalize = __commonJS({
  "../../node_modules/lorem-ipsum/dist/util/capitalize.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = void 0;
    var capitalize = /* @__PURE__ */ __name(function capitalize2(str) {
      var trimmed = str.trim();
      return trimmed.charAt(0).toUpperCase() + trimmed.slice(1);
    }, "capitalize");
    var _default = capitalize;
    exports["default"] = _default;
  }
});

// ../../node_modules/lorem-ipsum/dist/util/isNode.js
var require_isNode = __commonJS({
  "../../node_modules/lorem-ipsum/dist/util/isNode.js"(exports, module) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = void 0;
    var isNode = /* @__PURE__ */ __name(function isNode2() {
      return typeof module !== "undefined" && !!module.exports;
    }, "isNode");
    var _default = isNode;
    exports["default"] = _default;
  }
});

// ../../node_modules/lorem-ipsum/dist/util/isReactNative.js
var require_isReactNative = __commonJS({
  "../../node_modules/lorem-ipsum/dist/util/isReactNative.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = void 0;
    var isReactNative = /* @__PURE__ */ __name(function isReactNative2() {
      var isReactNativeResult = false;
      try {
        isReactNativeResult = navigator.product === "ReactNative";
      } catch (e) {
        isReactNativeResult = false;
      }
      return isReactNativeResult;
    }, "isReactNative");
    var _default = isReactNative;
    exports["default"] = _default;
  }
});

// ../../node_modules/lorem-ipsum/dist/constants/platforms.js
var require_platforms = __commonJS({
  "../../node_modules/lorem-ipsum/dist/constants/platforms.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.SUPPORTED_PLATFORMS = void 0;
    var SUPPORTED_PLATFORMS = {
      DARWIN: "darwin",
      LINUX: "linux",
      WIN32: "win32"
    };
    exports.SUPPORTED_PLATFORMS = SUPPORTED_PLATFORMS;
  }
});

// ../../node_modules/lorem-ipsum/dist/util/isWindows.js
var require_isWindows = __commonJS({
  "../../node_modules/lorem-ipsum/dist/util/isWindows.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = void 0;
    var _platforms = require_platforms();
    var isWindows = /* @__PURE__ */ __name(function isWindows2() {
      var isWindowsResult = false;
      try {
        isWindowsResult = process.platform === _platforms.SUPPORTED_PLATFORMS.WIN32;
      } catch (e) {
        isWindowsResult = false;
      }
      return isWindowsResult;
    }, "isWindows");
    var _default = isWindows;
    exports["default"] = _default;
  }
});

// ../../node_modules/lorem-ipsum/dist/util/makeArrayOfLength.js
var require_makeArrayOfLength = __commonJS({
  "../../node_modules/lorem-ipsum/dist/util/makeArrayOfLength.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = void 0;
    var makeArrayOfLength = /* @__PURE__ */ __name(function makeArrayOfLength2() {
      var length = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 0;
      return Array.apply(null, Array(length)).map(function(item, index) {
        return index;
      });
    }, "makeArrayOfLength");
    var _default = makeArrayOfLength;
    exports["default"] = _default;
  }
});

// ../../node_modules/lorem-ipsum/dist/util/makeArrayOfStrings.js
var require_makeArrayOfStrings = __commonJS({
  "../../node_modules/lorem-ipsum/dist/util/makeArrayOfStrings.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = void 0;
    var _makeArrayOfLength = _interopRequireDefault(require_makeArrayOfLength());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }
    __name(_interopRequireDefault, "_interopRequireDefault");
    var makeArrayOfStrings = /* @__PURE__ */ __name(function makeArrayOfStrings2(length, makeString) {
      var arr = (0, _makeArrayOfLength["default"])(length);
      return arr.map(function() {
        return makeString();
      });
    }, "makeArrayOfStrings");
    var _default = makeArrayOfStrings;
    exports["default"] = _default;
  }
});

// ../../node_modules/lorem-ipsum/dist/util/index.js
var require_util = __commonJS({
  "../../node_modules/lorem-ipsum/dist/util/index.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    Object.defineProperty(exports, "capitalize", {
      enumerable: true,
      get: /* @__PURE__ */ __name(function get() {
        return _capitalize["default"];
      }, "get")
    });
    Object.defineProperty(exports, "isNode", {
      enumerable: true,
      get: /* @__PURE__ */ __name(function get() {
        return _isNode["default"];
      }, "get")
    });
    Object.defineProperty(exports, "isReactNative", {
      enumerable: true,
      get: /* @__PURE__ */ __name(function get() {
        return _isReactNative["default"];
      }, "get")
    });
    Object.defineProperty(exports, "isWindows", {
      enumerable: true,
      get: /* @__PURE__ */ __name(function get() {
        return _isWindows["default"];
      }, "get")
    });
    Object.defineProperty(exports, "makeArrayOfLength", {
      enumerable: true,
      get: /* @__PURE__ */ __name(function get() {
        return _makeArrayOfLength["default"];
      }, "get")
    });
    Object.defineProperty(exports, "makeArrayOfStrings", {
      enumerable: true,
      get: /* @__PURE__ */ __name(function get() {
        return _makeArrayOfStrings["default"];
      }, "get")
    });
    var _capitalize = _interopRequireDefault(require_capitalize());
    var _isNode = _interopRequireDefault(require_isNode());
    var _isReactNative = _interopRequireDefault(require_isReactNative());
    var _isWindows = _interopRequireDefault(require_isWindows());
    var _makeArrayOfLength = _interopRequireDefault(require_makeArrayOfLength());
    var _makeArrayOfStrings = _interopRequireDefault(require_makeArrayOfStrings());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }
    __name(_interopRequireDefault, "_interopRequireDefault");
  }
});

// ../../node_modules/lorem-ipsum/dist/lib/generator.js
var require_generator = __commonJS({
  "../../node_modules/lorem-ipsum/dist/lib/generator.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = void 0;
    var _words = require_words();
    var _util = require_util();
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    __name(_classCallCheck, "_classCallCheck");
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    __name(_defineProperties, "_defineProperties");
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      Object.defineProperty(Constructor, "prototype", {
        writable: false
      });
      return Constructor;
    }
    __name(_createClass, "_createClass");
    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, {
          value,
          enumerable: true,
          configurable: true,
          writable: true
        });
      } else {
        obj[key] = value;
      }
      return obj;
    }
    __name(_defineProperty, "_defineProperty");
    var Generator = /* @__PURE__ */ function() {
      function Generator2() {
        var _ref = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, _ref$sentencesPerPara = _ref.sentencesPerParagraph, sentencesPerParagraph = _ref$sentencesPerPara === void 0 ? {
          max: 7,
          min: 3
        } : _ref$sentencesPerPara, _ref$wordsPerSentence = _ref.wordsPerSentence, wordsPerSentence = _ref$wordsPerSentence === void 0 ? {
          max: 15,
          min: 5
        } : _ref$wordsPerSentence, random = _ref.random, seed = _ref.seed, _ref$words = _ref.words, words = _ref$words === void 0 ? _words.WORDS : _ref$words;
        _classCallCheck(this, Generator2);
        _defineProperty(this, "sentencesPerParagraph", void 0);
        _defineProperty(this, "wordsPerSentence", void 0);
        _defineProperty(this, "random", void 0);
        _defineProperty(this, "words", void 0);
        if (sentencesPerParagraph.min > sentencesPerParagraph.max) {
          throw new Error("Minimum number of sentences per paragraph (".concat(sentencesPerParagraph.min, ") cannot exceed maximum (").concat(sentencesPerParagraph.max, ")."));
        }
        if (wordsPerSentence.min > wordsPerSentence.max) {
          throw new Error("Minimum number of words per sentence (".concat(wordsPerSentence.min, ") cannot exceed maximum (").concat(wordsPerSentence.max, ")."));
        }
        this.sentencesPerParagraph = sentencesPerParagraph;
        this.words = words;
        this.wordsPerSentence = wordsPerSentence;
        this.random = random || Math.random;
      }
      __name(Generator2, "Generator");
      _createClass(Generator2, [
        {
          key: "generateRandomInteger",
          value: /* @__PURE__ */ __name(function generateRandomInteger(min, max) {
            return Math.floor(this.random() * (max - min + 1) + min);
          }, "generateRandomInteger")
        },
        {
          key: "generateRandomWords",
          value: /* @__PURE__ */ __name(function generateRandomWords(num) {
            var _this = this;
            var _this$wordsPerSentenc = this.wordsPerSentence, min = _this$wordsPerSentenc.min, max = _this$wordsPerSentenc.max;
            var length = num || this.generateRandomInteger(min, max);
            return (0, _util.makeArrayOfLength)(length).reduce(function(accumulator, index) {
              return "".concat(_this.pluckRandomWord(), " ").concat(accumulator);
            }, "").trim();
          }, "generateRandomWords")
        },
        {
          key: "generateRandomSentence",
          value: /* @__PURE__ */ __name(function generateRandomSentence(num) {
            return "".concat((0, _util.capitalize)(this.generateRandomWords(num)), ".");
          }, "generateRandomSentence")
        },
        {
          key: "generateRandomParagraph",
          value: /* @__PURE__ */ __name(function generateRandomParagraph(num) {
            var _this2 = this;
            var _this$sentencesPerPar = this.sentencesPerParagraph, min = _this$sentencesPerPar.min, max = _this$sentencesPerPar.max;
            var length = num || this.generateRandomInteger(min, max);
            return (0, _util.makeArrayOfLength)(length).reduce(function(accumulator, index) {
              return "".concat(_this2.generateRandomSentence(), " ").concat(accumulator);
            }, "").trim();
          }, "generateRandomParagraph")
        },
        {
          key: "pluckRandomWord",
          value: /* @__PURE__ */ __name(function pluckRandomWord() {
            var min = 0;
            var max = this.words.length - 1;
            var index = this.generateRandomInteger(min, max);
            return this.words[index];
          }, "pluckRandomWord")
        }
      ]);
      return Generator2;
    }();
    var _default = Generator;
    exports["default"] = _default;
  }
});

// ../../node_modules/lorem-ipsum/dist/lib/LoremIpsum.js
var require_LoremIpsum = __commonJS({
  "../../node_modules/lorem-ipsum/dist/lib/LoremIpsum.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports["default"] = void 0;
    var _formats = require_formats();
    var _lineEndings = require_lineEndings();
    var _generator = _interopRequireDefault(require_generator());
    var _util = require_util();
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }
    __name(_interopRequireDefault, "_interopRequireDefault");
    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }
    __name(_classCallCheck, "_classCallCheck");
    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor)
          descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }
    __name(_defineProperties, "_defineProperties");
    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps)
        _defineProperties(Constructor.prototype, protoProps);
      if (staticProps)
        _defineProperties(Constructor, staticProps);
      Object.defineProperty(Constructor, "prototype", {
        writable: false
      });
      return Constructor;
    }
    __name(_createClass, "_createClass");
    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, {
          value,
          enumerable: true,
          configurable: true,
          writable: true
        });
      } else {
        obj[key] = value;
      }
      return obj;
    }
    __name(_defineProperty, "_defineProperty");
    var LoremIpsum = /* @__PURE__ */ function() {
      function LoremIpsum2() {
        var options = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
        var format = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : _formats.FORMAT_PLAIN;
        var suffix = arguments.length > 2 ? arguments[2] : void 0;
        _classCallCheck(this, LoremIpsum2);
        this.format = format;
        this.suffix = suffix;
        _defineProperty(this, "generator", void 0);
        if (_formats.FORMATS.indexOf(format.toLowerCase()) === -1) {
          throw new Error("".concat(format, " is an invalid format. Please use ").concat(_formats.FORMATS.join(" or "), "."));
        }
        this.generator = new _generator["default"](options);
      }
      __name(LoremIpsum2, "LoremIpsum");
      _createClass(LoremIpsum2, [
        {
          key: "getLineEnding",
          value: /* @__PURE__ */ __name(function getLineEnding() {
            if (this.suffix) {
              return this.suffix;
            }
            if (!(0, _util.isReactNative)() && (0, _util.isNode)() && (0, _util.isWindows)()) {
              return _lineEndings.LINE_ENDINGS.WIN32;
            }
            return _lineEndings.LINE_ENDINGS.POSIX;
          }, "getLineEnding")
        },
        {
          key: "formatString",
          value: /* @__PURE__ */ __name(function formatString(str) {
            if (this.format === _formats.FORMAT_HTML) {
              return "<p>".concat(str, "</p>");
            }
            return str;
          }, "formatString")
        },
        {
          key: "formatStrings",
          value: /* @__PURE__ */ __name(function formatStrings(strings) {
            var _this = this;
            return strings.map(function(str) {
              return _this.formatString(str);
            });
          }, "formatStrings")
        },
        {
          key: "generateWords",
          value: /* @__PURE__ */ __name(function generateWords(num) {
            return this.formatString(this.generator.generateRandomWords(num));
          }, "generateWords")
        },
        {
          key: "generateSentences",
          value: /* @__PURE__ */ __name(function generateSentences(num) {
            return this.formatString(this.generator.generateRandomParagraph(num));
          }, "generateSentences")
        },
        {
          key: "generateParagraphs",
          value: /* @__PURE__ */ __name(function generateParagraphs(num) {
            var makeString = this.generator.generateRandomParagraph.bind(this.generator);
            return this.formatStrings((0, _util.makeArrayOfStrings)(num, makeString)).join(this.getLineEnding());
          }, "generateParagraphs")
        }
      ]);
      return LoremIpsum2;
    }();
    var _default = LoremIpsum;
    exports["default"] = _default;
  }
});

// ../../node_modules/lorem-ipsum/dist/index.js
var require_dist = __commonJS({
  "../../node_modules/lorem-ipsum/dist/index.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    Object.defineProperty(exports, "LoremIpsum", {
      enumerable: true,
      get: /* @__PURE__ */ __name(function get() {
        return _LoremIpsum["default"];
      }, "get")
    });
    exports.loremIpsum = void 0;
    var _formats = require_formats();
    var _units = require_units();
    var _words = require_words();
    var _LoremIpsum = _interopRequireDefault(require_LoremIpsum());
    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : {
        "default": obj
      };
    }
    __name(_interopRequireDefault, "_interopRequireDefault");
    var loremIpsum2 = /* @__PURE__ */ __name(function loremIpsum3() {
      var _ref = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, _ref$count = _ref.count, count = _ref$count === void 0 ? 1 : _ref$count, _ref$format = _ref.format, format = _ref$format === void 0 ? _formats.FORMAT_PLAIN : _ref$format, _ref$paragraphLowerBo = _ref.paragraphLowerBound, paragraphLowerBound = _ref$paragraphLowerBo === void 0 ? 3 : _ref$paragraphLowerBo, _ref$paragraphUpperBo = _ref.paragraphUpperBound, paragraphUpperBound = _ref$paragraphUpperBo === void 0 ? 7 : _ref$paragraphUpperBo, random = _ref.random, _ref$sentenceLowerBou = _ref.sentenceLowerBound, sentenceLowerBound = _ref$sentenceLowerBou === void 0 ? 5 : _ref$sentenceLowerBou, _ref$sentenceUpperBou = _ref.sentenceUpperBound, sentenceUpperBound = _ref$sentenceUpperBou === void 0 ? 15 : _ref$sentenceUpperBou, _ref$units = _ref.units, units = _ref$units === void 0 ? _units.UNIT_SENTENCES : _ref$units, _ref$words = _ref.words, words = _ref$words === void 0 ? _words.WORDS : _ref$words, _ref$suffix = _ref.suffix, suffix = _ref$suffix === void 0 ? "" : _ref$suffix;
      var options = {
        random,
        sentencesPerParagraph: {
          max: paragraphUpperBound,
          min: paragraphLowerBound
        },
        words,
        wordsPerSentence: {
          max: sentenceUpperBound,
          min: sentenceLowerBound
        }
      };
      var lorem = new _LoremIpsum["default"](options, format, suffix);
      switch (units) {
        case _units.UNIT_PARAGRAPHS:
        case _units.UNIT_PARAGRAPH:
          return lorem.generateParagraphs(count);
        case _units.UNIT_SENTENCES:
        case _units.UNIT_SENTENCE:
          return lorem.generateSentences(count);
        case _units.UNIT_WORDS:
        case _units.UNIT_WORD:
          return lorem.generateWords(count);
        default:
          return "";
      }
    }, "loremIpsum");
    exports.loremIpsum = loremIpsum2;
  }
});

// src/channel-mock.ts
import { TextChannel, ChannelType, ForumChannel, ThreadChannel, Message as Message2, Invite, Collection, SnowflakeUtil as SnowflakeUtil2, NewsChannel, MessageReaction, DiscordAPIError, MessagePayload as MessagePayload2 } from "discord.js";

// ../discordjs-utils/src/snowflake.ts
import { SnowflakeUtil } from "discord.js";
function getRandomTime(start, end) {
  if (!start) {
    start = new Date(2015, 0, 1);
  }
  if (!end) {
    end = /* @__PURE__ */ new Date();
  }
  return new Date(start.getTime() + Math.random() * (end.getTime() - start.getTime()));
}
__name(getRandomTime, "getRandomTime");
function randomSnowflake(start, end) {
  return SnowflakeUtil.generate({
    timestamp: getRandomTime(start, end)
  });
}
__name(randomSnowflake, "randomSnowflake");
function isSnowflakeLargerAsInt(a, b) {
  return !isSnowflakeLarger(a, b) ? -1 : isSnowflakeLarger(a, b) ? 1 : 0;
}
__name(isSnowflakeLargerAsInt, "isSnowflakeLargerAsInt");
function isSnowflakeLarger(a, b) {
  const aAsBigInt = BigInt(a);
  const bAsBigInt = BigInt(b);
  return aAsBigInt > bAsBigInt;
}
__name(isSnowflakeLarger, "isSnowflakeLarger");

// ../discordjs-utils/src/message.ts
function sortMessagesById(messages) {
  return messages.sort((a, b) => isSnowflakeLargerAsInt(a.id, b.id));
}
__name(sortMessagesById, "sortMessagesById");

// src/guild-mock.ts
import { PermissionsBitField as PermissionsBitField2, Guild, Role } from "discord.js";

// src/user-mock.ts
import { ClientUser, GuildMember, PermissionsBitField, User } from "discord.js";
function mockUser(client, data = {}) {
  const rawData = {
    id: randomSnowflake().toString(),
    username: "USERNAME",
    discriminator: "user#0000",
    avatar: "user avatar url",
    bot: false,
    ...data
  };
  const user = Reflect.construct(User, [
    client,
    rawData
  ]);
  client.users.cache.set(user.id, user);
  return user;
}
__name(mockUser, "mockUser");
function mockClientUser(client, override = {}) {
  const rawData = {
    id: process.env.DISCORD_CLIENT_ID ?? process.env.VITEST_DISCORD_CLIENT_ID ?? randomSnowflake().toString(),
    username: "test",
    discriminator: "0000",
    avatar: null,
    bot: false,
    ...override
  };
  const clientUser = Reflect.construct(ClientUser, [
    client,
    rawData
  ]);
  client.user = clientUser;
  client.user.id = rawData.id;
  return clientUser;
}
__name(mockClientUser, "mockClientUser");
function mockGuildMember(input) {
  const { client, permissions = PermissionsBitField.Default, data = {} } = input;
  let { user, guild } = input;
  if (!user) {
    user = mockUser(client);
  }
  if (!guild) {
    guild = mockGuild(client, user);
  }
  const role = mockRole(client, permissions, guild);
  const rawData = {
    guild_id: guild.id,
    roles: [
      role.id
    ],
    deaf: false,
    user: {
      id: user.id
    },
    joined_at: "33",
    mute: false,
    ...data
  };
  const member = Reflect.construct(GuildMember, [
    client,
    rawData,
    guild
  ]);
  guild.members.cache.set(member.id, member);
  return member;
}
__name(mockGuildMember, "mockGuildMember");

// ../utils/src/id.ts
var import_lorem_ipsum = __toESM(require_dist());

// ../utils/src/select.ts
var omit = /* @__PURE__ */ __name((obj, ...keys) => {
  const _ = {
    ...obj
  };
  keys.forEach((key) => delete _[key]);
  return _;
}, "omit");

// src/guild-mock.ts
function mockGuild(client, owner, data = {}) {
  if (!owner) {
    owner = mockUser(client);
  }
  const guildId = data.id ?? randomSnowflake().toString();
  const rawData = {
    id: guildId,
    owner_id: owner.id,
    verification_level: 0,
    emojis: [],
    icon: "guild icon url",
    mfa_level: 0,
    hub_type: 0,
    features: [],
    roles: [],
    name: "guild name",
    description: "guild description",
    default_message_notifications: 0,
    banner: "guild banner url",
    splash: "guild splash url",
    discovery_splash: "guild discovery splash url",
    region: "",
    afk_channel_id: null,
    afk_timeout: 60,
    explicit_content_filter: 0,
    application_id: null,
    system_channel_id: null,
    system_channel_flags: 0,
    rules_channel_id: null,
    vanity_url_code: null,
    premium_tier: 0,
    preferred_locale: "",
    public_updates_channel_id: null,
    nsfw_level: 0,
    stickers: [],
    premium_progress_bar_enabled: false,
    ...omit(data, "id")
  };
  const guild = Reflect.construct(Guild, [
    client,
    rawData
  ]);
  mockRole(client, PermissionsBitField2.Default, guild, {
    name: "everyone",
    id: guild.id
  });
  client.guilds.cache.set(guild.id, guild);
  mockGuildMember({
    client,
    user: owner,
    guild
  });
  mockGuildMember({
    client,
    user: client.user,
    guild
  });
  guild.members.fetch = async (id) => {
    if (typeof id === "object") {
      id = id.user;
    }
    const member = guild.members.cache.get(id);
    if (member)
      return Promise.resolve(member);
    return Promise.reject(new Error("Member not found"));
  };
  return guild;
}
__name(mockGuild, "mockGuild");
function mockRole(client, permissions, guild, role = {}) {
  if (!guild) {
    guild = mockGuild(client);
  }
  const roleData = {
    color: 0,
    hoist: false,
    id: randomSnowflake().toString(),
    managed: false,
    mentionable: false,
    name: "test",
    position: 0,
    permissions: PermissionsBitField2.resolve(permissions).toString(),
    ...role
  };
  const createdRole = Reflect.construct(Role, [
    client,
    roleData,
    guild
  ]);
  guild.roles.cache.set(createdRole.id, createdRole);
  return createdRole;
}
__name(mockRole, "mockRole");

// src/message-mock.ts
import { Message, MessageType, MessagePayload, Embed, ActionRow, GuildEmoji, ReactionEmoji } from "discord.js";
function mockEmbed(data) {
  return Reflect.construct(Embed, [
    data
  ]);
}
__name(mockEmbed, "mockEmbed");
function mockActionRow(data) {
  return Reflect.construct(ActionRow, [
    data
  ]);
}
__name(mockActionRow, "mockActionRow");
function applyMessagePayload(payload, message) {
  var _a, _b;
  if (typeof payload === "string") {
    message.content = payload;
  }
  if (payload instanceof MessagePayload) {
    throw new Error("Not implemented");
  }
  if (typeof payload !== "string") {
    message.embeds = ((_a = payload.embeds) == null ? void 0 : _a.map(mockEmbed)) ?? message.embeds;
    message.content = payload.content ?? message.content;
    message.components = ((_b = payload.components) == null ? void 0 : _b.map((comp) => mockActionRow(comp))) ?? message.components;
  }
  return message;
}
__name(applyMessagePayload, "applyMessagePayload");
function mockMessage(input) {
  const { client, override = {} } = input;
  let { author, channel } = input;
  if (!channel) {
    channel = mockTextChannel(client);
  }
  if (!author) {
    author = mockUser(client);
    if (!channel.isDMBased()) {
      mockGuildMember({
        client,
        user: author,
        guild: channel.guild
      });
    }
  }
  const rawData = {
    id: randomSnowflake().toString(),
    channel_id: channel.id,
    author: {
      // TODO: Use a helper function to get properties
      id: author.id,
      username: author.username,
      discriminator: author.discriminator,
      avatar: author.avatar
    },
    content: "",
    timestamp: "",
    edited_timestamp: null,
    tts: false,
    mention_everyone: false,
    mentions: [],
    mention_roles: [],
    attachments: [],
    embeds: [],
    pinned: false,
    type: MessageType.Default,
    reactions: [],
    ...override
  };
  const message = Reflect.construct(Message, [
    client,
    rawData
  ]);
  channel.messages.cache.set(message.id, message);
  message.react = async (emoji) => {
    const isCustomEmoji = typeof emoji === "string" && emoji.startsWith("<:");
    if (emoji instanceof GuildEmoji) {
      throw new Error("Not implement");
    }
    if (emoji instanceof ReactionEmoji) {
      throw new Error("Not implement");
    }
    return Promise.resolve(mockReaction({
      message,
      user: client.user,
      override: {
        emoji: {
          id: isCustomEmoji ? emoji : null,
          name: isCustomEmoji ? null : emoji
        }
      }
    }));
  };
  message.startThread = async (options) => Promise.resolve(mockThreadFromParentMessage({
    client,
    parentMessage: message,
    data: options
  }));
  message.edit = (payload) => {
    return Promise.resolve(applyMessagePayload(payload, message));
  };
  message.delete = () => {
    channel == null ? void 0 : channel.messages.cache.delete(message.id);
    return Promise.resolve(message);
  };
  return message;
}
__name(mockMessage, "mockMessage");

// src/channel-mock.ts
function getGuildTextChannelMockDataBase(type, guild) {
  const rawData = {
    id: randomSnowflake().toString(),
    type,
    position: 0,
    default_auto_archive_duration: 60,
    rate_limit_per_user: 0,
    flags: 0,
    guild_id: guild == null ? void 0 : guild.id,
    last_message_id: null,
    last_pin_timestamp: null,
    name: "channel name",
    nsfw: false,
    parent_id: null,
    permission_overwrites: [],
    topic: "channel topic"
  };
  return rawData;
}
__name(getGuildTextChannelMockDataBase, "getGuildTextChannelMockDataBase");
function setupMockedChannel(client, guild, createMockData) {
  if (!guild) {
    guild = mockGuild(client);
  }
  const channel = createMockData(guild);
  if (channel.type === ChannelType.GuildText || channel.type === ChannelType.GuildAnnouncement || channel.type === ChannelType.GuildForum) {
    channel.threads.fetchActive = () => {
      const activeThreads = [
        ...channel.threads.cache.values()
      ].filter((thread) => !thread.archived || thread.archived == null);
      const output = {
        threads: new Collection(activeThreads.map((thread) => [
          thread.id,
          thread
        ])),
        hasMore: false
      };
      return Promise.resolve(output);
    };
    channel.threads.fetchArchived = jest.fn().mockImplementation((options = {}) => {
      let filteredThreads = [
        ...channel.threads.cache.sorted((a, b) => isSnowflakeLargerAsInt(a.id, b.id)).values()
      ].filter((thread) => thread.archived);
      if (options.type) {
        filteredThreads = filteredThreads.filter((thread) => {
          const isPublicThread = thread.type === ChannelType.PublicThread;
          const isPrivateThread = thread.type === ChannelType.PrivateThread;
          if (options.type === "public" && isPublicThread) {
            return true;
          }
          if (options.type === "private" && isPrivateThread) {
            return true;
          }
          return false;
        });
      }
      filteredThreads = filteredThreads.filter((thread) => {
        let beforeTime = options.before;
        if (beforeTime == void 0) {
          return true;
        }
        if (beforeTime instanceof Date || typeof beforeTime === "number") {
          beforeTime = SnowflakeUtil2.generate({
            timestamp: beforeTime
          }).toString();
        }
        if (beforeTime instanceof ThreadChannel) {
          beforeTime = beforeTime.id;
        }
        return isSnowflakeLarger(thread.id, beforeTime);
      });
      if (options.limit) {
        filteredThreads = filteredThreads.slice(0, options.limit);
      }
      const output = {
        threads: new Collection(filteredThreads.map((thread) => [
          thread.id,
          thread
        ])),
        hasMore: false
      };
      return Promise.resolve(output);
    });
    channel.createInvite = () => {
      const invite = mockInvite(client, channel);
      return Promise.resolve(invite);
    };
  }
  if (channel.isTextBased()) {
    channel.send = (options) => {
      const isMessagePayload = options instanceof MessagePayload2;
      const opts = isMessagePayload ? options.options : options;
      const message = mockMessage({
        client,
        channel,
        author: client.user,
        override: {
          content: typeof opts === "string" ? opts : opts.content ?? ""
        }
      });
      return Promise.resolve(message);
    };
    channel.messages.fetch = jest.fn().mockImplementation((q = {}) => {
      if (q instanceof Message2) {
        return Promise.resolve(q);
      }
      if (typeof q === "string") {
        const message = channel.messages.cache.get(q);
        if (!message) {
          return Promise.reject(new DiscordAPIError({
            code: 10008,
            message: "NOT FOUND"
          }, 10008, 404, "GET", "/channels/123/messages/123", {
            files: []
          }));
        }
        return Promise.resolve(message);
      }
      if ("message" in q) {
        const resolvable = q.message;
        if (resolvable instanceof Message2) {
          return Promise.resolve(q);
        }
        if (typeof resolvable === "string") {
          const message = channel.messages.cache.get(resolvable);
          if (!message) {
            return Promise.reject(new DiscordAPIError({
              code: 10008,
              message: "NOT FOUND"
            }, 10008, 404, "GET", "/channels/123/messages/123", {
              files: []
            }));
          }
          return Promise.resolve(message);
        }
        throw new Error("Invalid message");
      }
      const { after } = q;
      let { limit } = q;
      if (!limit) {
        limit = 100;
      }
      const sortedCachedMessages = sortMessagesById(Array.from(channel.messages.cache.values()));
      const filteredMessages = sortedCachedMessages.filter((message) => {
        if (!after)
          return true;
        return isSnowflakeLarger(message.id, after);
      });
      const messages = filteredMessages.slice(0, limit);
      jest.clearAllMocks();
      const asCollection = new Collection(messages.map((message) => [
        message.id,
        message
      ]));
      return Promise.resolve(asCollection);
    });
  }
  client.channels.cache.set(channel.id, channel);
  guild.channels.cache.set(channel.id, channel);
  return channel;
}
__name(setupMockedChannel, "setupMockedChannel");
function mockTextChannel(client, guild, data = {}) {
  return setupMockedChannel(client, guild, (guild2) => {
    const rawData = {
      ...getGuildTextChannelMockDataBase(ChannelType.GuildText, guild2),
      ...data
    };
    const channel = Reflect.construct(TextChannel, [
      guild2,
      rawData,
      client
    ]);
    return channel;
  });
}
__name(mockTextChannel, "mockTextChannel");
function mockThreadFromParentMessage(input) {
  const { client, parentMessage, data = {} } = input;
  if (parentMessage) {
    if (parentMessage && (parentMessage.channel.type === ChannelType.GuildText || parentMessage.channel.type === ChannelType.GuildAnnouncement)) {
      return mockPublicThread({
        client,
        parentChannel: parentMessage.channel,
        data: {
          id: parentMessage.id,
          ...data
        }
      });
    }
  }
  throw new Error("Invalid parent message");
}
__name(mockThreadFromParentMessage, "mockThreadFromParentMessage");
function mockPublicThread(input) {
  const { client, data = {} } = input;
  let { parentChannel } = input;
  return setupMockedChannel(client, parentChannel == null ? void 0 : parentChannel.guild, (guild) => {
    if (!parentChannel) {
      parentChannel = mockTextChannel(client, guild);
    }
    const rawData = {
      ...getGuildTextChannelMockDataBase(ChannelType.PublicThread, guild),
      member: {
        id: randomSnowflake().toString(),
        user_id: randomSnowflake().toString(),
        join_timestamp: (/* @__PURE__ */ new Date()).toISOString(),
        flags: 0
      },
      guild_id: guild.id,
      parent_id: parentChannel.id,
      applied_tags: [],
      message_count: 0,
      member_count: 0,
      thread_metadata: {
        archived: false,
        auto_archive_duration: 60,
        archive_timestamp: (/* @__PURE__ */ new Date()).toISOString(),
        locked: false
      },
      ...data
    };
    const thread = Reflect.construct(ThreadChannel, [
      guild,
      rawData,
      client
    ]);
    parentChannel.threads.cache.set(thread.id, thread);
    return thread;
  });
}
__name(mockPublicThread, "mockPublicThread");
function mockForumChannel(client, guild, data = {}) {
  return setupMockedChannel(client, guild, (guild2) => {
    const rawData = {
      ...getGuildTextChannelMockDataBase(ChannelType.GuildForum, guild2),
      available_tags: [
        {
          id: randomSnowflake().toString(),
          name: "test tag",
          emoji_id: null,
          emoji_name: null,
          moderated: false
        }
      ],
      default_reaction_emoji: null,
      default_sort_order: null,
      ...data
    };
    const channel = Reflect.construct(ForumChannel, [
      guild2,
      rawData,
      client
    ]);
    return channel;
  });
}
__name(mockForumChannel, "mockForumChannel");
function mockNewsChannel(input) {
  return setupMockedChannel(input.client, input.guild, (guild) => {
    const rawData = {
      ...getGuildTextChannelMockDataBase(ChannelType.GuildAnnouncement, guild),
      ...input.data
    };
    const channel = Reflect.construct(NewsChannel, [
      guild,
      rawData,
      input.client
    ]);
    return channel;
  });
}
__name(mockNewsChannel, "mockNewsChannel");
function mockMessages(channel, numberOfMessages) {
  const messages = [];
  for (let id = 1; id <= numberOfMessages; id++) {
    messages.push(mockMessage({
      client: channel.client,
      channel
    }));
  }
  return messages;
}
__name(mockMessages, "mockMessages");
function mockMessageReaction({ message, reacter, override }) {
  var _a, _b;
  const data = {
    channel_id: message.channel.id,
    count: 1,
    emoji: {
      id: randomSnowflake().toString(),
      name: "\u{1F44D}"
    },
    user_id: reacter.id,
    message_id: message.id,
    guild_id: (_a = message.guild) == null ? void 0 : _a.id,
    me: reacter.id === ((_b = message.client.user) == null ? void 0 : _b.id),
    ...override
  };
  const messageReaction = Reflect.construct(MessageReaction, [
    message.client,
    data,
    message
  ]);
  return messageReaction;
}
__name(mockMessageReaction, "mockMessageReaction");
function mockReaction({ message, user, override }) {
  var _a, _b;
  const data = {
    channel_id: message.channel.id,
    message_id: message.id,
    user_id: user.id,
    guild_id: (_a = message.guild) == null ? void 0 : _a.id,
    count: 1,
    emoji: {
      id: randomSnowflake().toString(),
      name: "\u{1F44D}"
    },
    me: user.id === ((_b = message.client.user) == null ? void 0 : _b.id),
    ...override
  };
  const reaction = Reflect.construct(MessageReaction, [
    message.client,
    data,
    message
  ]);
  const emojiId = data.emoji.name ?? data.emoji.id;
  if (!emojiId) {
    throw new Error("Emoji ID and name cannot be null");
  }
  message.reactions.cache.set(emojiId, reaction);
  return reaction;
}
__name(mockReaction, "mockReaction");
function mockMarkedAsSolvedReply({ client, questionId, solutionId, channel, override = {} }) {
  const markedAsSolvedReply = mockMessage({
    client,
    author: client.user,
    override: {
      embeds: [
        {
          fields: [
            {
              name: "Solution Message ID",
              value: solutionId,
              inline: true
            },
            {
              name: "Question Message ID",
              value: questionId,
              inline: true
            }
          ]
        }
      ],
      ...override
    },
    channel
  });
  return markedAsSolvedReply;
}
__name(mockMarkedAsSolvedReply, "mockMarkedAsSolvedReply");
function mockInvite(client, channel, override = {}) {
  if (!channel) {
    channel = mockTextChannel(client);
  }
  const inviteData = {
    // random 5 letter string
    code: Math.random().toString(36).substring(2, 7),
    channel: {
      id: channel.id,
      name: channel.name,
      type: channel.type
    },
    ...override
  };
  const invite = Reflect.construct(Invite, [
    client,
    inviteData
  ]);
  return invite;
}
__name(mockInvite, "mockInvite");

// src/client-mock.ts
import { Client, Options } from "discord.js";
async function setupBot(override = {}) {
  const client = mockClient(override);
  await client.login();
  return client;
}
__name(setupBot, "setupBot");
function mockClient(override = {
  // Cache everything is used to simulate API responses, removes the limit
  makeCache: Options.cacheEverything()
}) {
  const client = new Client({
    intents: [],
    ...override
  });
  applyClientMocks(client);
  return client;
}
__name(mockClient, "mockClient");
function applyClientMocks(client) {
  Client.prototype.login = async () => Promise.resolve("");
  mockClientUser(client);
}
__name(applyClientMocks, "applyClientMocks");

// src/interaction-mock.ts
import { ChatInputCommandInteraction, InteractionType, ApplicationCommandType, PermissionsBitField as PermissionsBitField3, ButtonInteraction, ComponentType, InteractionResponse } from "discord.js";

// src/to-api-data.ts
import { ChannelType as ChannelType2 } from "discord.js";
function userToAPIUser(user) {
  var _a;
  return {
    id: user.id,
    username: user.username,
    discriminator: user.discriminator,
    avatar: user.avatar,
    accent_color: user.accentColor,
    banner: user.banner,
    bot: user.bot,
    flags: (_a = user.flags) == null ? void 0 : _a.bitfield,
    system: user.system
  };
}
__name(userToAPIUser, "userToAPIUser");
function channelToAPIChannelMention(channel) {
  if (channel.isDMBased()) {
    throw new Error("Cannot mention a DM channel");
  }
  return {
    id: channel.id,
    guild_id: channel.guild.id,
    name: channel.name,
    type: channel.type
  };
}
__name(channelToAPIChannelMention, "channelToAPIChannelMention");
function messageToAPIData(message) {
  var _a, _b;
  return {
    id: message.id,
    attachments: [],
    author: userToAPIUser(message.author),
    channel_id: message.channel.id,
    content: message.content,
    edited_timestamp: ((_a = message.editedAt) == null ? void 0 : _a.toISOString()) ?? null,
    embeds: [],
    flags: (_b = message.flags) == null ? void 0 : _b.bitfield,
    mention_everyone: message.mentions.everyone,
    mention_roles: message.mentions.roles.map((role) => role.id),
    mentions: message.mentions.users.map((user) => userToAPIUser(user)),
    pinned: message.pinned,
    timestamp: message.createdAt.toISOString(),
    tts: message.tts,
    type: message.type,
    mention_channels: message.mentions.channels.map(channelToAPIChannelMention),
    nonce: message.nonce ?? void 0,
    position: message.position ?? void 0
  };
}
__name(messageToAPIData, "messageToAPIData");

// src/interaction-mock.ts
function setupMockedInteractionAPIData({ channel, caller, message = void 0, type, applicationId = void 0, override = {} }) {
  return {
    application_id: applicationId ?? randomSnowflake().toString(),
    channel_id: channel.id,
    id: randomSnowflake().toString(),
    token: randomSnowflake().toString(),
    version: 1,
    app_permissions: PermissionsBitField3.Default.toString(),
    locale: "en-US",
    guild_id: channel.isDMBased() ? void 0 : channel.guild.id,
    user: {
      id: caller.id,
      avatar: caller.avatar,
      discriminator: caller.discriminator,
      username: caller.username
    },
    data: {},
    guild_locale: "en-US",
    message: message ? messageToAPIData(message) : void 0,
    type,
    ...override
  };
}
__name(setupMockedInteractionAPIData, "setupMockedInteractionAPIData");
function applyInteractionResponseHandlers(interaction) {
  const client = interaction.client;
  if ("update" in interaction) {
    interaction.update = async (options) => {
      interaction.deferred = false;
      await interaction.message.edit(options);
      if (options instanceof Object && "fetchReply" in options) {
        return interaction.message;
      }
      return mockInteractionResponse({
        interaction,
        id: interaction.id
      });
    };
  }
  if ("deferUpdate" in interaction) {
    interaction.deferUpdate = (options) => {
      interaction.deferred = true;
      if (options == null ? void 0 : options.fetchReply) {
        return Promise.resolve(interaction.message);
      }
      return Promise.resolve(mockInteractionResponse({
        id: interaction.id,
        interaction
      }));
    };
  }
  if ("deferReply" in interaction) {
    interaction.deferReply = (options) => {
      interaction.deferred = true;
      const msg = mockMessage({
        client,
        channel: interaction.channel ?? void 0,
        author: interaction.client.user,
        override: {
          id: interaction.id.toString()
        }
      });
      if (options == null ? void 0 : options.fetchReply) {
        return Promise.resolve(msg);
      }
      return Promise.resolve(mockInteractionResponse({
        id: interaction.id,
        interaction
      }));
    };
  }
  if ("reply" in interaction) {
    interaction.reply = (opts) => {
      console.log(interaction.id);
      const msg = mockMessage({
        client,
        channel: interaction.channel ?? void 0,
        author: interaction.client.user,
        override: {
          id: interaction.id.toString()
        }
      });
      interaction.deferred = false;
      interaction.replied = true;
      console.log("applying message payload");
      applyMessagePayload(opts, msg);
      console.log("applied message payload");
      if (opts instanceof Object && "fetchReply" in opts) {
        console.log("returning message");
        return msg;
      }
      console.log("returning interaction response");
      return Promise.resolve(mockInteractionResponse({
        interaction,
        id: interaction.id
      }));
    };
  }
  if ("fetchReply" in interaction) {
    interaction.fetchReply = () => {
      var _a;
      if (interaction.isChatInputCommand() || interaction.isContextMenuCommand()) {
        const msg = (_a = interaction.channel) == null ? void 0 : _a.messages.cache.get(interaction.id);
        if (!msg)
          throw new Error("Message not found");
        return Promise.resolve(msg);
      } else {
        if (!interaction.message)
          throw new Error("No message to edit");
        return Promise.resolve(interaction.message);
      }
    };
  }
  if ("editReply" in interaction) {
    interaction.editReply = async (opts) => {
      var _a;
      interaction.deferred = false;
      interaction.replied = true;
      if (interaction.isChatInputCommand() || interaction.isContextMenuCommand()) {
        const message = await interaction.fetchReply();
        return message.edit(opts);
      } else {
        if (!interaction.message)
          throw new Error("No message to edit");
        return (_a = interaction.message) == null ? void 0 : _a.edit(opts);
      }
    };
  }
}
__name(applyInteractionResponseHandlers, "applyInteractionResponseHandlers");
function mockChatInputCommandInteraction(client, name, id, guild, channel, member) {
  if (!guild) {
    guild = mockGuild(client);
  }
  if (!channel) {
    channel = mockTextChannel(client, guild);
  }
  if (!member) {
    member = mockGuildMember({
      client,
      guild
    });
  }
  const rawData = {
    ...setupMockedInteractionAPIData({
      caller: member.user,
      channel,
      type: InteractionType.ApplicationCommand,
      applicationId: id
    }),
    data: {
      id,
      name,
      type: ApplicationCommandType.ChatInput,
      guild_id: guild.id
    }
  };
  const command = Reflect.construct(ChatInputCommandInteraction, [
    client,
    rawData
  ]);
  applyInteractionResponseHandlers(command);
  return command;
}
__name(mockChatInputCommandInteraction, "mockChatInputCommandInteraction");
function mockInteractionResponse({ interaction, id }) {
  return Reflect.construct(InteractionResponse, [
    interaction,
    id
  ]);
}
__name(mockInteractionResponse, "mockInteractionResponse");
function mockButtonInteraction({ override = {}, caller, message }) {
  const client = message.client;
  const customId = override.custom_id ?? randomSnowflake().toString();
  const rawData = {
    component_type: ComponentType.Button,
    custom_id: customId,
    message: messageToAPIData(message),
    ...override,
    ...setupMockedInteractionAPIData({
      caller,
      channel: message.channel,
      type: InteractionType.MessageComponent,
      message,
      override
    }),
    data: {
      component_type: ComponentType.Button,
      custom_id: customId
    }
  };
  const interaction = Reflect.construct(ButtonInteraction, [
    client,
    rawData
  ]);
  applyInteractionResponseHandlers(interaction);
  return interaction;
}
__name(mockButtonInteraction, "mockButtonInteraction");

// src/helpers.ts
import { PermissionFlagsBits } from "discord.js";
async function delay(timeInMs) {
  if (!timeInMs)
    timeInMs = process.env.DEFAULT_DELAY_IN_MS ? parseInt(process.env.DEFAULT_DELAY_IN_MS) : 500;
  await new Promise((resolve) => setTimeout(resolve, timeInMs));
}
__name(delay, "delay");
async function emitEvent(client, event, ...args) {
  const status = client.emit(event, ...args);
  await delay();
  return status;
}
__name(emitEvent, "emitEvent");
function overrideVariables(obj, overrides) {
  Object.assign(obj, overrides);
}
__name(overrideVariables, "overrideVariables");
function copyClass(obj, client, overrides = {}) {
  const created = Object.assign(
    // eslint-disable-next-line @typescript-eslint/no-unsafe-argument
    Object.create(Object.getPrototypeOf(obj)),
    obj
  );
  overrideVariables(created, {
    client,
    ...overrides
  });
  return created;
}
__name(copyClass, "copyClass");
async function testAllPermissions({ permissionsThatShouldWork, operation }) {
  for await (const permission of Object.keys(PermissionFlagsBits)) {
    const permissionIsAllowed = permissionsThatShouldWork.includes(permission);
    await operation(permission, permissionIsAllowed);
  }
}
__name(testAllPermissions, "testAllPermissions");

// src/scenarios.ts
import { PermissionFlagsBits as PermissionFlagsBits2 } from "discord.js";
async function createGuildMemberVariants(client, guild = void 0) {
  if (!guild)
    guild = mockGuild(client);
  const guildMemberOwner = await guild.members.fetch(guild.ownerId);
  const guildMemberDefault = mockGuildMember({
    client,
    guild
  });
  const pendingGuildMemberDefault = mockGuildMember({
    client,
    guild,
    data: {
      pending: true
    }
  });
  const guildMemberManageGuild = mockGuildMember({
    client,
    guild,
    permissions: PermissionFlagsBits2.ManageGuild
  });
  const guildMemberAdmin = mockGuildMember({
    client,
    guild,
    permissions: PermissionFlagsBits2.Administrator
  });
  return {
    guildMemberOwner,
    guildMemberDefault,
    pendingGuildMemberDefault,
    guildMemberManageGuild,
    guildMemberAdmin
  };
}
__name(createGuildMemberVariants, "createGuildMemberVariants");
export {
  applyClientMocks,
  copyClass,
  createGuildMemberVariants,
  delay,
  emitEvent,
  getGuildTextChannelMockDataBase,
  mockButtonInteraction,
  mockChatInputCommandInteraction,
  mockClient,
  mockClientUser,
  mockForumChannel,
  mockGuild,
  mockGuildMember,
  mockInteractionResponse,
  mockInvite,
  mockMarkedAsSolvedReply,
  mockMessageReaction,
  mockMessages,
  mockNewsChannel,
  mockPublicThread,
  mockReaction,
  mockRole,
  mockTextChannel,
  mockThreadFromParentMessage,
  mockUser,
  overrideVariables,
  setupBot,
  testAllPermissions
};
//# sourceMappingURL=index.js.map